<template>
    <div class="wrapper">
        <v-row class="pt-5">
            <v-col class="text-left">
        <v-btn
            class="text--white mx-1"
            color="primary"
            @click="addVariant(false)"
            large
        >
            <v-icon>mdi-plus</v-icon>
            {{ $t('add_variant') }}
        </v-btn>
            </v-col>
        </v-row>

<!--       added variants-->
        <v-row v-if="!!variants.length" v-for="(local, index) in localValue" :key="local.nonce">
            <div class="col flex-grow-0 align-self-center">
                <v-btn
                    class="error"
                    @click="removeVariant(index)"
                    icon
                >
                    <v-icon color="white">mdi-minus</v-icon>
                </v-btn>
            </div>

            <v-col>
                <div class="field-label">{{ $t('name') }}</div>
                <v-combobox
                    v-model="localValue[index]"
                    item-text="name"
                    hide-selected
                    hide-details
                    outlined
                    disabled
                >
                </v-combobox>
            </v-col>

            <v-col>
                <div class="field-label">{{ $tc('option', 2) }}</div>
                <variant-option-box
                    v-model="localValue[index].options"
                    :options="addedOptions(localValue[index])"
                    :hide-details="true"
                >
                </variant-option-box>
            </v-col>
        </v-row>

        <v-row v-if="isShow">
            <div class="col flex-grow-0 align-self-center">
                <v-btn
                    class="error"
                    @click="clearVariant"
                    icon
                >
                    <v-icon color="white">mdi-minus</v-icon>
                </v-btn>
            </div>

            <v-col>
                <div class="field-label">{{ $t('name') }}</div>
                <v-select
                    v-model="selectedVariant"
                    item-text="name"
                    item-value="variant_id"
                    :items="variants"
                    :loading="loading"
                    :error-messages="errors"
                    hide-selected
                    return-object
                    outlined
                    :menu-props="{ bottom: true, offsetY: true }"
                >
                </v-select>
            </v-col>
            <v-col>
                <div class="field-label">{{ $tc('option', 2) }}</div>
                <variant-option-box
                    v-model="selectedVariantOptions"
                    :options="variantOptions"
                >
                </variant-option-box>
            </v-col>
        </v-row>

        <v-snackbar
            v-model="snackbar.show"
            :color="snackbar.color"
            :timeout="snackbar.timeout"
            absolute
        >
            {{ snackbar.message }}

            <template v-slot:action="{ attrs }">
                <v-btn
                    icon
                    color="white"
                    v-bind="attrs"
                    @click="snackbar.show = false"
                >
                    <v-icon>mdi-close</v-icon>
                </v-btn>
            </template>
        </v-snackbar>
    </div>
</template>

<script>
    import VariantOptionBox from "./VariantOptionBox";
    export default {
        name: "VariantBox",
        components: {VariantOptionBox},
        props: {
            value: Array,
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            clearable: {
                type: Boolean,
                default: false
            },
            mode: {
                type: String,
                default: 'create',
                validator: value => ['create', 'edit'].indexOf(value) !== -1
            }
        },

        data: () => ({
            snackbar: {
                show: false,
                color: 'error',
                timeout: 6000,
                message: ''
            },
            selectedVariant: null,
            selectedVariantOptions: [],
            nonce: 1,
            loading: true,
            variants: [],
            isShow:false
        }),

        watch: {
            selectedVariant(val) {
                this.selectedVariantOptions = [];
            }
        },

        computed: {
            localValue: {
                get() {
                    return this.value;
                },

                set(val) {
                    return this.$emit('input', val);
                }
            },

            variantOptions() {
                return this.selectedVariant ? this.selectedVariant.options : [];
            }
        },

        mounted() {
            this.fetchVariants()
                .then(data => {
                    this.variants = this.mapVariantId(data);
                    this.loading = false;
                })
        },

        methods: {
            fetchVariants() {
                return new Promise((resolve) => {
                    axios.get('api/products/variants')
                        .then(({ data }) => {
                            resolve(data);
                        })
                })
            },

            addVariant(isSubmit = false) {
                if(this.isShow==false && isSubmit == false){
                    this.isShow=true
                    return
                }
                if(this.selectedVariant) {
                    if(this.isVariantUnique() && !!this.selectedVariantOptions.length) {
                        if(isSubmit==true) {
                            this.isShow=false
                        }
                            this.localValue.push({
                            ...this.selectedVariant,
                            options: this.selectedVariantOptions
                        });

                        this.selectedVariant = null;
                        this.selectedVariantOptions = [];
                    }
                    else if(this.selectedVariantOptions.length === 0) {
                        this.snackbar.show = true;
                        this.snackbar.message = this.$t('variant_options_empty');
                    }
                    else {
                        this.snackbar.show = true;
                        this.snackbar.message = this.$t('variant_unique');
                    }
                }
                else {
                    if(isSubmit!=true) {
                        this.snackbar.show = true;
                        this.snackbar.message = this.$t('variant_empty');
                    }
                }
            },
            clearVariant(){
                this.selectedVariant = null;
                this.selectedVariantOptions = [];
                this.isShow = false;
            },
            isVariantUnique() {
                const selected = this.selectedVariant.variant_id;

                const result = this.localValue.find(variant => variant.variant_id === selected);

                return result === undefined || result === null;
            },

            mapVariantId(variants) {
                if(this.mode === 'create') {
                    return variants.map(variant => {
                        variant.variant_id = variant.id;
                        delete variant.id;

                        variant.options = variant.options.map(option => {
                            option.variant_option_id = option.id;
                            delete option.id;

                            return option;
                        });

                        return variant;
                    });
                }
                else {
                    return variants;
                }
            },

            addedOptions(variant) {
                const id = variant.variant_id;

                const result = this.variants.find(v => v.variant_id === id);

                return result.options;
            },

            removeVariant(index) {
                this.localValue.splice(index, 1);
            }
        }
    }
</script>

<style scoped>
    .wrapper {
        display: flex;
        flex-direction: column;
    }
</style>
